﻿using Infragistics.Controls.Grids;
using System.Collections.Generic;
using System.Windows;

namespace Test
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();

            this.view.ColumnLayoutAssigned += GridColumnLayoutAssigned;
        }

        private void GridColumnLayoutAssigned(object sender, ColumnLayoutAssignedEventArgs e)
        {
            ViewModel contextViewModel = this.DataContext as ViewModel;
            if (contextViewModel == null)
                return;

            ColumnBaseCollection columns = e.ColumnLayout.Columns;
            
            foreach (KeyValuePair<string,int> value in contextViewModel.Data[0].Values)
            {
                string headerKey = "Group" + value.Key;                
                var groupCol = new GroupColumn() { Key = headerKey, Tag = value.Key, HeaderText = headerKey };
                    columns.Add(groupCol);

                string colKey = value.Key;
                string colKey2 = colKey + "_2";
                var col = new UnboundColumn() { Key = colKey, HeaderText = colKey, ItemTemplate = TryFindResource("MyDataTemplate") as DataTemplate };
                var col2 = new UnboundColumn() { Key = colKey2, HeaderText = colKey2, Tag = colKey2, ItemTemplate = TryFindResource("MyDataTemplate") as DataTemplate };                
                groupCol.Columns.Add(col);
                groupCol.Columns.Add(col2); 
            }
        }
    }
}